#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QSerialPort>
#include "MessageDecoder.h"

QT_BEGIN_NAMESPACE
namespace Ui { class MainWindow; }
QT_END_NAMESPACE

struct MessageStateAutomat {
    char text[20]; // SidL0011223344556677
    int currPointer;
    bool discard; // отбрасывать сообщение или нет
    MessageStruct message;
};

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    MessageStateAutomat automat = {{0}, -1, true, {}};
    std::vector<MessageStruct> messages;

    explicit MainWindow(QWidget *parent = nullptr);
    
    ~MainWindow() override;

private slots:
    void on_updatePortsButton_clicked();
    void on_connectButton_clicked();
    void on_disconnect_clicked();
    void on_clearLog_clicked();
    void on_storeToFile_clicked();
    void on_loadFromFile_clicked();
    void on_generateTextFile_clicked();

private:
    static QString messageToString(const MessageStruct& msg);
    void putCharToMessage(char data);
    void readDataHandler();
    void updatePortsList();

    Ui::MainWindow *ui;
    QSerialPort* serial;
};
#endif // MAINWINDOW_H
