//
// Created by vlad on 21.01.2022.
//

#ifndef SDP_SNIFFER_QT_MESSAGEDECODER_H
#define SDP_SNIFFER_QT_MESSAGEDECODER_H

#include <cstdint>
#include <string>

struct MessageStruct {
    uint16_t stdId;
    uint8_t dataLen;
    uint8_t data[8];
    uint64_t milliseconds;
};

// MAC - все доступные
#define MAC_ID_MULTICAST (-1)

// MAC - не определен
#define MAC_ID_UNDEFINED (-2)


class MessageDecoder {
private:
    MessageStruct msg;
public:
    explicit MessageDecoder(const MessageStruct& message);

    int getGroup() const;
    int getMsgId() const;
    int getSrcMac() const;
    int getDestMac() const;
    std::string getMessageDescription() const;
    std::string getDataFrameDescription() const;

    std::string toString() const;

    ~MessageDecoder() = default;
};


#endif //SDP_SNIFFER_QT_MESSAGEDECODER_H
